#include <IRremote.h>

int RECV_PIN = 11;

IRrecv irrecv(RECV_PIN);
decode_results results;

// RGB Led Control
const int yellowLEDPin = 10;    // LED connected to digital pin 9
const int redLEDPin = 9;     // LED connected to digital pin 8
const int blueLEDPin = 8; 

boolean ch_free; // Canale libero o occupato

void setup() {
  
  irrecv.enableIRIn(); // Start the receiver
  
  pinMode(6, OUTPUT); // Motor 2
  pinMode(5, OUTPUT); // Motor 1
  pinMode(13, OUTPUT); //Led (opzionale)
  
  // pin RGB Led
  pinMode(yellowLEDPin,OUTPUT);
  pinMode(redLEDPin,OUTPUT);
  pinMode(blueLEDPin,OUTPUT);
  
  //randomSeed(85); 

}

void loop() {
  
  ascolto_canale();
  
}

void ascolto_canale() {

    // Se il canale è libero -> LED Verde altrimenti ROSSO
  if (ch_free) {
      digitalWrite(redLEDPin, LOW);
      digitalWrite(yellowLEDPin, HIGH);
      digitalWrite(blueLEDPin, HIGH);
      //Stop motori
      analogWrite(6, 0);
      analogWrite(5, 0);
  } else {
      digitalWrite(redLEDPin, LOW);
      digitalWrite(yellowLEDPin, HIGH);
      digitalWrite(blueLEDPin, HIGH);
  }
  
     // Ricezione dati IR
    if (irrecv.decode(&results)) {
    
      ch_free = false;
      
      // Led diventa rosso quando si ricevono dati

//      digitalWrite(redLEDPin, HIGH);
//      digitalWrite(yellowLEDPin, LOW);
//      digitalWrite(blueLEDPin, LOW);
      

//      Serial.println(results.value, DEC);
                // Controllo il valore esadecimale in ricezione
          switch(results.value) {
            case (0x12A):
                      analogWrite(6, random(90,130));
                      analogWrite(5, random(90,130));
                      
                      analogWrite(redLEDPin, 40);
                      analogWrite(yellowLEDPin, 95);
                      analogWrite(blueLEDPin, 0);
                      
            break;
            case (0x12B):
                      analogWrite(6, random(130,180));
                      analogWrite(5, random(130,180));
                      
                      analogWrite(redLEDPin, 185);
                      analogWrite(yellowLEDPin, 0);
                      analogWrite(blueLEDPin, 185);
            break;
            case (0x12C):
                      analogWrite(6, random(180,250));
                      analogWrite(5, random(180,250));
                      
                      analogWrite(redLEDPin, 255);
                      analogWrite(yellowLEDPin, 0);
                      analogWrite(blueLEDPin, 0);
            break;
          
          }
      irrecv.resume();
    }
    delay(100);
    ch_free = true;
}
